/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreElementHierarchyGroup.TCoreElementHierarchyGroupPath;
import de.ship.db.tables.records.TCoreElementHierarchyAndGroupRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * Variable reference for hierarchy element groups. See t_core_element_hierarchy
 * group.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreElementHierarchyAndGroup extends TableImpl<TCoreElementHierarchyAndGroupRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of
     * <code>common_dd.t_core_element_hierarchy_and_group</code>
     */
    public static final TCoreElementHierarchyAndGroup T_CORE_ELEMENT_HIERARCHY_AND_GROUP = new TCoreElementHierarchyAndGroup();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreElementHierarchyAndGroupRecord> getRecordType() {
        return TCoreElementHierarchyAndGroupRecord.class;
    }

    /**
     * The column
     * <code>common_dd.t_core_element_hierarchy_and_group.lastchange</code>.
     */
    public final TableField<TCoreElementHierarchyAndGroupRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_element_hierarchy_and_group.pk</code>.
     */
    public final TableField<TCoreElementHierarchyAndGroupRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column
     * <code>common_dd.t_core_element_hierarchy_and_group.fk_element</code>.
     */
    public final TableField<TCoreElementHierarchyAndGroupRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column
     * <code>common_dd.t_core_element_hierarchy_and_group.group_id</code>.
     */
    public final TableField<TCoreElementHierarchyAndGroupRecord, Integer> GROUP_ID = createField(DSL.name("group_id"), SQLDataType.INTEGER.nullable(false), this, "");

    private TCoreElementHierarchyAndGroup(Name alias, Table<TCoreElementHierarchyAndGroupRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreElementHierarchyAndGroup(Name alias, Table<TCoreElementHierarchyAndGroupRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment("Variable reference for hierarchy element groups. See t_core_element_hierarchy group."), TableOptions.table(), where);
    }

    /**
     * Create an aliased
     * <code>common_dd.t_core_element_hierarchy_and_group</code> table reference
     */
    public TCoreElementHierarchyAndGroup(String alias) {
        this(DSL.name(alias), T_CORE_ELEMENT_HIERARCHY_AND_GROUP);
    }

    /**
     * Create an aliased
     * <code>common_dd.t_core_element_hierarchy_and_group</code> table reference
     */
    public TCoreElementHierarchyAndGroup(Name alias) {
        this(alias, T_CORE_ELEMENT_HIERARCHY_AND_GROUP);
    }

    /**
     * Create a <code>common_dd.t_core_element_hierarchy_and_group</code> table
     * reference
     */
    public TCoreElementHierarchyAndGroup() {
        this(DSL.name("t_core_element_hierarchy_and_group"), null);
    }

    public <O extends Record> TCoreElementHierarchyAndGroup(Table<O> path, ForeignKey<O, TCoreElementHierarchyAndGroupRecord> childPath, InverseForeignKey<O, TCoreElementHierarchyAndGroupRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_ELEMENT_HIERARCHY_AND_GROUP);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreElementHierarchyAndGroupPath extends TCoreElementHierarchyAndGroup implements Path<TCoreElementHierarchyAndGroupRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreElementHierarchyAndGroupPath(Table<O> path, ForeignKey<O, TCoreElementHierarchyAndGroupRecord> childPath, InverseForeignKey<O, TCoreElementHierarchyAndGroupRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreElementHierarchyAndGroupPath(Name alias, Table<TCoreElementHierarchyAndGroupRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreElementHierarchyAndGroupPath as(String alias) {
            return new TCoreElementHierarchyAndGroupPath(DSL.name(alias), this);
        }

        @Override
        public TCoreElementHierarchyAndGroupPath as(Name alias) {
            return new TCoreElementHierarchyAndGroupPath(alias, this);
        }

        @Override
        public TCoreElementHierarchyAndGroupPath as(Table<?> alias) {
            return new TCoreElementHierarchyAndGroupPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreElementHierarchyAndGroupRecord, Integer> getIdentity() {
        return (Identity<TCoreElementHierarchyAndGroupRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreElementHierarchyAndGroupRecord> getPrimaryKey() {
        return Keys.PK_CORE_ELEMENT_HIERARCHY_AND_GROUP;
    }

    @Override
    public List<UniqueKey<TCoreElementHierarchyAndGroupRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_ELEMENT_HIERARCHY_AND_GROUP_FK_ELEMENT);
    }

    @Override
    public List<ForeignKey<TCoreElementHierarchyAndGroupRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_ELEMENT_HIERARCHY_AND_GROUP__FK_CORE_ELEMENT_HIERARCHY_AND_GROUP_GROUP_ID, Keys.T_CORE_ELEMENT_HIERARCHY_AND_GROUP__FK_CORE_ELEMENT_HIERARCHY_AND_GROUP_FK_ELEMENT);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_CORE_ELEMENT_HIERARCHY_AND_GROUP__FK_CORE_ELEMENT_HIERARCHY_AND_GROUP_GROUP_ID, null);

        return _tCoreElementHierarchy;
    }

    private transient TCoreElementHierarchyGroupPath _tCoreElementHierarchyGroup;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy_group</code> table.
     */
    public TCoreElementHierarchyGroupPath tCoreElementHierarchyGroup() {
        if (_tCoreElementHierarchyGroup == null)
            _tCoreElementHierarchyGroup = new TCoreElementHierarchyGroupPath(this, Keys.T_CORE_ELEMENT_HIERARCHY_AND_GROUP__FK_CORE_ELEMENT_HIERARCHY_AND_GROUP_FK_ELEMENT, null);

        return _tCoreElementHierarchyGroup;
    }

    @Override
    public TCoreElementHierarchyAndGroup as(String alias) {
        return new TCoreElementHierarchyAndGroup(DSL.name(alias), this);
    }

    @Override
    public TCoreElementHierarchyAndGroup as(Name alias) {
        return new TCoreElementHierarchyAndGroup(alias, this);
    }

    @Override
    public TCoreElementHierarchyAndGroup as(Table<?> alias) {
        return new TCoreElementHierarchyAndGroup(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementHierarchyAndGroup rename(String name) {
        return new TCoreElementHierarchyAndGroup(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementHierarchyAndGroup rename(Name name) {
        return new TCoreElementHierarchyAndGroup(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementHierarchyAndGroup rename(Table<?> name) {
        return new TCoreElementHierarchyAndGroup(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchyAndGroup where(Condition condition) {
        return new TCoreElementHierarchyAndGroup(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchyAndGroup where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchyAndGroup where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchyAndGroup where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementHierarchyAndGroup where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementHierarchyAndGroup where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementHierarchyAndGroup where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementHierarchyAndGroup where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchyAndGroup whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchyAndGroup whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
